App = Ember.Application.create({
	//LOG_TRANSITIONS: true,
	//LOG_VIEW_LOOKUPS: true,
	//LOG_ACTIVE_GENERATION: true,
	/*modalLoader: {
		msg: null,
		type: 'loader',
		loading: true,
		searchBtn: false,
		closeBtn: false,
	}*/
});


App.deferReadiness();


DS.RESTAdapter.registerTransform('raw', {
    deserialize: function(serialized) {
        return serialized;
    },
    serialize: function(deserialized) {
        return deserialized;
    }
});



Ember.Handlebars.registerBoundHelper('date', function(date) {
	return moment(date).format("DD.MM.YYYY");
});

Ember.Handlebars.registerBoundHelper('ago', function(date) {
	return moment(date).fromNow();
});

Ember.Handlebars.registerBoundHelper('promotion', function(value) {
	if(value === false){
		return '';
	}else{
		var result = new Handlebars.SafeString('<div class="promo"><div>promo</div></div>')
		return result;

	}
});




var app = {
	apiUrl: 'http://apps.observatoiredesprix.nc',
	apiNamespace: 'api/l9x4ojuk320080g3l58f252axzggtxd37p9ary6a34255jg19n',
	database: null,
	gaPlugin: null,
	screen: {
		height: window.innerHeight,
		width: window.innerWidth
	},
	historique: [],
	devicePlatform: null,

	communes:[{"name":"Boulouparis ","postal_code":"98812"},{"name":"Bourail","postal_code":"98870"},{"name":"Canala","postal_code":"98813"},{"name":"Dumbéa","postal_code":"98830"},{"name":"Farino","postal_code":"98881"},{"name":"Hienghène","postal_code":"98815"},{"name":"Houaïlou","postal_code":"98816"},{"name":"Kaala-Gomen","postal_code":"98817"},{"name":"Koné","postal_code":"98860"},{"name":"Kouaoua","postal_code":"98818"},{"name":"Koumac","postal_code":"98850"},{"name":"La Foa","postal_code":"98880"},{"name":"Le Mont-Dore","postal_code":"98810"},{"name":"Lifou","postal_code":"98820"},{"name":"Maré","postal_code":"98878"},{"name":"Moindou","postal_code":"98819"},{"name":"Nouméa","postal_code":"98800"},{"name":"Ouvéa","postal_code":"98814"},{"name":"Ouégoa","postal_code":"98821"},{"name":"Païta","postal_code":"98890"},{"name":"Poindimié","postal_code":"98822"},{"name":"Ponérihouen","postal_code":"98823"},{"name":"Pouembout","postal_code":"98825"},{"name":"Poum","postal_code":"98826"},{"name":"Pouébo","postal_code":"98824"},{"name":"Poya","postal_code":"98827"},{"name":"Sarraméa","postal_code":"98880"},{"name":"Thio","postal_code":"98829"},{"name":"Touho","postal_code":"98831"},{"name":"Voh","postal_code":"98831"},{"name":"Yaté","postal_code":"98834"},{"name":"Île des Pins","postal_code":"98832"},{"name":"îles Belep","postal_code":"98811"}],


	postalCode:function(){
		var commune = window.localStorage.getItem('commune');
		if(commune){
			return tools.communeSelected(commune);
		}else{
			return '';
		}
	},

	emberHistory: {
		back: false,
		forward: true,
		length: 0
	},

	scanner: null,
	network: null,
    initialize: function() {
        this.bindEvents();
    },

    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener("resume", this.onResume, false);
		document.addEventListener("pause", this.onPause, false);
    },

    onDeviceReady: function() {
	    app.receivedEvent('deviceready');

        new FastClick(document.body);

		app.devicePlatform = device.platform;

		app.deviceSpecific();

		//app.scanner = cordova.require("com.phonegap.plugins.barcodescanner.barcodescanner");
		app.scanner = window.plugins.barcodeScanner;

		app.startApp();

		setTimeout(function() {
			navigator.splashscreen.hide();
		}, 1200);
    },

    startApp: function(){
		// loads the data from web sql storage into app.historique in database.js
		historique.SQLproducts();
		// defining new adapter for history
		App.Store.registerAdapter('App.Historique', DS.FixtureAdapter);

		App.ProductsAdapter = DS.RESTAdapter.extend({});

		// load data into fixtures
		App.Historique.FIXTURES = app.historique;

		App.advanceReadiness();
    },

    onPause: function(id) {
		//navigator.splashscreen.show();
    },

    onResume: function(id) {
	    app.receivedEvent('onresume');
		var network = navigator.connection.type;

		if(network == 'none'){
			if($('header.unfold').length){
				tools.toggleSearch();
			}
		}


		/*setTimeout(function() {
			navigator.splashscreen.hide();
		}, 500);*/
    },


    receivedEvent: function(id) {
		app.network = navigator.connection.type;
    	if(app.network != Connection.NONE){
	        app.gaPlugin = window.plugins.gaPlugin;
			app.gaPlugin.init(app.gaPluginInit, app.gaPluginErrorHandler, "UA-5338598-43", 10);
    	}
    },

    deviceSpecific: function(){

		if( app.devicePlatform == 'Android' ){
			App.Menu.set('android', true);
		}else{
			if ( parseFloat(device.version) >= 7.0) {
				$('html').addClass('iOS7')
			}
		}

    },

	gaPluginInit: function() {
		//Track an open event
		app.gaPlugin.trackEvent(function() { }, app.gaPluginErrorHandler, "App", "Open", "App", 10);
		app.gaPlugin.available = true;
	},

	gaPluginErrorHandler: function(result) {
		console.log('gaPluginErrorHandler: '+result);
	},

    historiqueLoaded: function(){
		App.__container__.lookup('controller:historiques').set("model", App.Historique.find())
    },

	scan: function(scanner, transitionTo){
		var overlay = [];

		if (device.platform == 'iOS' && parseFloat(device.version) < 7.0) {
			overlay = ["scannerOverlay"];
		}

        try {
            scanner.scan(
            	function(result) {
	                console.log("Scanner result: \n" +
	                    "text: " + result.text + "\n" +
	                    "format: " + result.format + "\n" +
	                    "cancelled: " + result.cancelled + "\n");


	                if(result.format == "EAN_13"){
	                    //app.ean13(result.text);
	                    transitionTo(result.text)
	                }else if( !result.cancelled ){
		                app.badFormat(result.text, result.format);
	                }
				},
				function (error) {
					console.log('error + ' + error);
					// need to show a modal
					var content = App.Modal.create({
						msg: 'Une erreur s\'est produite ! Veuillez recommencer.',
						type: 'alert',
						closeBtn: true,
						loading: false,
						searchBtn: false,
					});
					App.__container__.lookup('controller:application').send("showModal", content);
				}, overlay
			);


        } catch (ex) {
        	console.log('catch error');
            console.log(ex.message);
        }
	},

	badFormat : function(text, format){
		console.log('badFormat = ' + format);
		var content = App.Modal.create({
			msg: 'Le code barre scanné n\'est pas reconnu. Ce code barre doit comporter 13 chiffres',
			type: 'alert',
			closeBtn: true,
			loading: false,
			searchBtn: false,
		});
		App.__container__.lookup('controller:application').send("showModal", content);
	},

	ean13 : function(id){
		console.log('ean13 = ' + id);
		App.Router.router.transitionTo('/products/'+id+'/index')
	}
};

