App.ApplicationController = Ember.Controller.extend({
	searchQuery:'',
	scannedProduct: false,

	toggleMenu: function(){
		tools.toggleMenu();
	},

	backBtn: function(){
		var body = $('body'),
			productView = body.find('.product-view'),
			modalView = body.find('.overlay');

		if (app.emberHistory.length < -1) {
			backBtn.hide();
		}

		if (productView.length && this.prevPath == 'products.index' || this.prevPath == 'historiques.index') {
			productView.removeClass('product-view');
			setTimeout(function() {
				window.history.back();
				app.emberHistory.length = app.emberHistory.length-2;
			}, 500);
		} else {
			if(this.prevPath == 'products.index'){
				this.get('target').send("closeModal", false);
			}

			window.history.back();
			app.emberHistory.length = app.emberHistory.length-2;
		}

		if (modalView.length) {
			this.get('target').send("closeModal", true);
		}

	},

	pathMemory: null,

	currentPathDidChange: function() {
		var path = this.get('currentPath'),
			backBtn = $('.back-button'),
			isScanned = this.get('scannedProduct'),
			that = this;


        if (this.pathMemory){
            this.set('prevPath',this.pathMemory);
        }

        this.pathMemory = this.get('currentPath');

		app.emberHistory.length++;

		if(app.emberHistory.length === 1){
			backBtn.hide();
		}else{
			backBtn.show();
		}


		if($('header.unfold').length && path != 'products.index'){
			tools.toggleSearch();
		}

		var newtitle = '',
			bodyID = '',
			body = $('body');


		if( path == 'products.index' || path == 'test' ){
			newtitle = 'Recherche';
			bodyID = 'search';
			body.find('.container').removeClass('product-view');

		}else if( path == 'products.product'|| path == 'products.product.index'){
			newtitle = 'Produit';
			bodyID = 'search';
			//body.find('.container').addClass('product-view');
			//added from route

		}else if( path ==  'historiques.index' ){
			newtitle = 'Historique';
			bodyID = 'search';
			body.find('.container').removeClass('product-view');

		}else if( path ==  'historiques.historique' ){
			newtitle = 'Historique';
			bodyID = 'search';
			body.find('.container').addClass('product-view');

		}else if(path == 'index'){
			newtitle = 'Observatoire des prix';
			bodyID = 'home';
		}else if(path == 'gouvernement'){
			newtitle = 'Gouvernement';
			bodyID = 'gouvernement';
		}else if(path == 'preferences'){
			newtitle = 'Préférences';
			bodyID = 'gouvernement';
		}else if(path == 'infos'){
			newtitle = 'A Propos';
			bodyID = 'infos';
		}else if(path == 'viechere'){
			newtitle = 'Vie Chère';
			bodyID = 'vie-chere';
		}

		body.attr('id', bodyID);


		setTimeout(function(){
			tools.updateTitle(newtitle);

			var url = that.target.get('url');

			if( !url.length ){
				url = 'home';
			}else if( path == 'products.product.index' ){
				url = url.replace('/index', '')
				if( isScanned ){
					url = 'SCANNED:' + url;
				}
			}else if( path == 'products.index' ){
				var query = that.get('searchQuery');
				url = 'SEARCH:' + url + '/' + query;
			}

			if('undefined' != typeof(app.gaPlugin) && app.gaPlugin.available){
				app.gaPlugin.trackPage( function(){}, app.gaPluginErrorHandler, url);
			}


		}, 0)

		this.set('scannedProduct', false)

	}.observes('currentPath'),



	doSearch: function() {
		// the current value of the text field
		var searchquery = this.get('searchQuery'),
			currentPath = this.get('currentPath'),
			header = $('header'),
			popup = $('.popup'),
			that = this;


		if(!searchquery.length){
			var noQuerymsg = {
				msg: 'Aucune recherche',
				type: 'no-result',
				searchBtn: true,
				loading: false,
				closeBtn: true,
			}
			var content = App.Modal.create(noQuerymsg);

			console.log(this)
			this.get('target').send("showModal", content);

			return;
		}

		header.find('.search-input').blur();

		this.set('searchRedirect', false);
        this.set('searchQuery', searchquery);

		this.transitionToRoute('products');
		//console.log(this)
		if( currentPath.indexOf("products") == -1){
			this.transitionToRoute('products');
		}else{
			//console.log('else')
			this.set('searchRedirect', true);
			this.transitionToRoute('index');
			this.send('currentPathDidChange');
		}

	}


});