
var historique = {

	db: window.openDatabase("Historique", "1.0", "ODP Historique", 2000000),

	SQLproducts: function(){
	    this.db.transaction(this.setupTable, this.dbErrorHandler, this.getEntries);
	},

	setupTable: function(tx){
        //tx.executeSql('DROP TABLE IF EXISTS PRODUCTS');
	    tx.executeSql("CREATE TABLE IF NOT EXISTS PRODUCTS(id unique,name,image,magasin,local,updated)");
	    console.log("after setupTable...");
	},

	dbErrorHandler: function(err){
    	console.log("DB Error 0: " + err.message + "\nCode=" + err.code);
	},
	dbErrorHandler1: function(err){
    	console.log("DB Error 1: " + err.message + "\nCode=" + err.code);
	},

	getEntries: function(){
		console.log('getEntries')

		historique.db.transaction(function(tx) {
			tx.executeSql("select id, name, image, magasin,local, updated from PRODUCTS order by updated desc",[], historique.renderEntries, historique.dbErrorHandler);
		}, historique.dbErrorHandler1);
	},

	renderEntries: function(tx, results){
		console.log('renderEntries')
		if (results.rows.length == 0) {
			console.log("You currently do not have any product history");
			//trigger data loading hack ;-)
			app.historiqueLoaded();
		} else {

			for(var i=0; i<results.rows.length; i++) {

					app.historique.push(results.rows.item(i));

					app.historique[i]['stores'] = JSON.parse(app.historique[i]['magasin']);
					app.historique[i]['ean'] = JSON.parse(app.historique[i]['id']);


					if( i+1 == results.rows.length){
						//trigger data loading hack ;-)
						app.historiqueLoaded();
					}
			}

		}

	},

	dbSaveError: function(err){
		if(err.code != 1){
	    	console.log("DB Saving Error : " + err.message + "\nCode=" + err.code);
		}else{
	    	console.log("DB Saving message: This id already exist");
		}
	},



	save: function(data, callback) {

		var id = data.id,
			name = data.name,
			image = data.image,
			local = (data.local == false) ? 0 : 1,
			stores = JSON.stringify(data.stores),
			newDate = new Date().getTime();

		historique.db.transaction(function(tx) {
			//check if more tahn 99
			//tx.executeSql( "select id, name, image, magasin, updated from PRODUCTS order by updated desc", [], success, error);

			function success(tx, results){
				console.log('SUCCESS')
				console.log(tx);
				console.log(results);
				console.log(results.rows.length);
			}
			function error(err){
				console.log('ERROR')
		    	console.log("DB Error 0: " + err.message + "\nCode=" + err.code);
			}
				// DELETE FROM PRODUCTS WHERE id IN (SELECT id FROM PRODUCTS ORDER by updated desc LIMIT 99,1)

			tx.executeSql(
				"select id, name, image, magasin, local, updated from PRODUCTS where id = ?",
				[id],
				function(tx, results){
					if (results.rows.length == 0) {
						//remove last row from table
						tx.executeSql( "delete from PRODUCTS where id in (select id from PRODUCTS order by updated desc LIMIT 99,1)", [], success, error);
						//insert new row at the top
						tx.executeSql("insert into PRODUCTS(id, name, image, magasin, local, updated) values(?,?,?,?,?,?)", [id, name, image, stores, local, newDate] );
						console.log('id does not exists so insert');
					}else{
						//update existing row
						tx.executeSql("update PRODUCTS set name=?, image=?, magasin=?, local=?, updated=? where id=?",[name, image, stores, local, newDate, id]);
						console.log('id exists so update date');
					}
				},
				function(tx, err){
					console.log(err)
				}
			);


		}, historique.dbSaveError, callback);
	}

}
