App.ProductsRoute = Ember.Route.extend({

	modalNoresult: function(data){
		return {
			msg: data,
			type: 'no-result',
			searchBtn: true,
			loading: false,
			closeBtn: true,
		}
	},


	setupController: function (controller, model) {
		this.controller.set('model', '');
		var query = this.controllerFor('application').get('searchQuery'),
			postalCode = app.postalCode(),
			that = this,
			productQuery;


		this.controllerFor('application').set('searchRedirect', false);

		if(query.length){
			productQuery = App.Product.find({ name: query, commune: postalCode });
			productQuery.then(
				function(products) {

					controller.set("noResult", false);
					//console.log('promise and isloaded check = ' + productQuery.get("isLoaded") + ' ' + new Date())

					controller.set('model', productQuery);

					that.controllerFor("application").send("closeModal", true)

					//console.log("Found " + products.get('length') + " products.");

				},
				function(error) {

					//the normal .then() callback is no working for some reason
					//so i am listening to 'ajaxComplete' instead to handle 404 only
				}
			)


			$(document).one('ajaxComplete', function(event, request, settings){
			    controller.set('status', request.status);

				$('.products-wrap').addClass('loaded');


			    if(request.status != '200'){
		        	var data = request.statusText;
					switch(data){
						case 'error':
						case 'timeout':
							data = 'La recherche a expirée';
							break;
						case 'offline':
							data = 'Vous n\'êtes pas connecté à Internet (3G/Wifi).';
							break;
					}

					controller.set("noResult", true);

					var content = App.Modal.create(that.modalNoresult(data));

					setTimeout(function(){
						that.controllerFor("application").send("showModal", content);
					}, 1000)

			    }

			});
		}//if query



	},

});

